import paramiko, os, json, requests

global config
config = {
    "server_host": "",
    "server_port": "",
    "server_username": "",
    "server_password": "",
    "list": {
        "vue": {
            "command": "cd /home/webhook-vue && git pull && npm install && npm run build"
        }
    }
}

def main_handler(event, context):
    global config

    if not 'queryString' in event.keys():
        print('参数错误')
        return False

    if not 'name' in event['queryString'].keys() or not event['queryString']['name']:
        print('参数错误')
        return False

    name = event['queryString']['name']

    # if config == None:
    #     config = request('url')

    if not 'list' in config.keys() or not name in config['list'].keys():
        print('参数错误')
        return False

    data = config['list'][name]

    if not 'command' in data.keys() or not data['command']:
        print('没有需要执行的命令')
        return False

    server_host = data['server_host'] if 'server_host' in data.keys() and data['server_host'] else config['server_host']
    server_port = data['server_port'] if 'server_port' in data.keys() and data['server_port'] else config['server_port']
    server_username = data['server_username'] if 'server_username' in data.keys() and data['server_username'] else config['server_username']
    server_password = data['server_password'] if 'server_password' in data.keys() else config['server_password']

    if not server_host or not server_port or not server_username:
        print('服务器参数错误')
        return False

    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.connect(
        hostname=server_host,
        port=server_port,
        username=server_username,
        password=server_password
    )
    stdin, stdout, stderr = ssh.exec_command(data['command'])

    for i in stdout.readlines():
        print(i)

    for i in stderr.readlines():
        print(i)

    ssh.close()

    return '执行完毕'

def request(url):
    i = 0

    while i < 5:
        try:
            r = requests.get(url)
            return r.json()
        except requests.exceptions.RequestException as e:
            i += 1
